#line 1 "E:/startup_codes/periferals/MCP2317_SPI_2/MCP2317_0.0/16f887_2317.c"

 unsigned char const MCP2317_IODIRA = 0x00;
 unsigned char const MCP2317_IPOLA = 0x02;
 unsigned char const MCP2317_GPINTENA = 0x04;
 unsigned char const MCP2317_DEFVALA = 0x06;
 unsigned char const MCP2317_INTCONA = 0x08;
 unsigned char const MCP2317_IOCONA = 0x0A;
 unsigned char const MCP2317_GPPUA = 0x0C;
 unsigned char const MCP2317_INTFA = 0x0E;
 unsigned char const MCP2317_INTCAPA = 0x10;
 unsigned char const MCP2317_GPIOA = 0x12;
 unsigned char const MCP2317_OLATA = 0x14;


 unsigned char const MCP2317_IODIRB =0x01;
 unsigned char const MCP2317_IPOLB =0x03;
 unsigned char const MCP2317_GPINTENB =0x05;
 unsigned char const MCP2317_DEFVALB =0x07;
 unsigned char const MCP2317_INTCONB =0x09;
 unsigned char const MCP2317_IOCONB =0x0B;
 unsigned char const MCP2317_GPPUB =0x0D;
 unsigned char const MCP2317_INTFB =0x0F;
 unsigned char const MCP2317_INTCAPB =0x11;
 unsigned char const MCP2317_GPIOB =0x13;
 unsigned char const MCP2317_OLATB =0x15;

 unsigned char const MCP2317_OPCODE_WRITE =0x40;
 unsigned char const MCP2317_OPCODE_READ =0x41;

 sbit CS at RC0_bit;
 sbit CS_Direction at TRISC0_bit;

 sbit reset at RC1_bit;
 sbit reset_Direction at TRISC1_bit;

 unsigned char letto_a=0x00 absolute 0x0020;
 unsigned char letto_b=0x00 absolute 0x0021;

 void MCP2317_Write(unsigned char const opcode,unsigned char const address, unsigned char dato);
 unsigned char MCP2317_Read(unsigned char const opcode, unsigned char const address);

void main()
{
char str[10];


 ANSEL=0;
 ANSELH=0;
 TRISC.B0=0;
 TRISC.B1=0;

 SPI1_Init();
 reset=0;
 delay_ms(100);
 reset=1;


 MCP2317_Write(MCP2317_OPCODE_WRITE,MCP2317_IOCONA,0x20);

 MCP2317_Write(MCP2317_OPCODE_WRITE,MCP2317_IOCONB,0x20);



 MCP2317_Write(MCP2317_OPCODE_WRITE,MCP2317_IODIRB,0x00);

 MCP2317_Write(MCP2317_OPCODE_WRITE,MCP2317_OLATB,0x00);



 MCP2317_Write(MCP2317_OPCODE_WRITE,MCP2317_IODIRA,0xFF);


 while (1)
 {



 letto_b=MCP2317_Read( MCP2317_OPCODE_READ,MCP2317_GPIOA);
 letto_b = letto_b & 0x01;
 if(letto_b == 0x01)
 {
 MCP2317_Write(MCP2317_OPCODE_WRITE,MCP2317_GPIOB,0xF0);
 Delay_ms(100);

 }
 else
 {
 MCP2317_Write(MCP2317_OPCODE_WRITE,MCP2317_GPIOB,0x0F);
 Delay_ms(100);
 }

 }

}

void MCP2317_Write( unsigned char const opcode,unsigned char const address,
 unsigned char dato)
{
 CS=0;
 SPI1_Write(opcode);
 SPI1_Write(address);
 SPI1_Write(dato);
 CS=1;
}

unsigned char MCP2317_Read(unsigned char const opcode,
 unsigned char const address)
{
 unsigned char letto_p;
 CS=0;
 SPI1_Write(opcode);
 SPI1_Write(address);
 letto_p=SPI1_Read(0);
 CS=1;
 return letto_p;
}
